/*
 * AddInputVar.java
 * =====================================================================
 * Copyright (C) 2009 Shawn E. Gano
 * 
 * This file is part of JSatTrak.
 * 
 * JSatTrak is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * JSatTrak is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with JSatTrak.  If not, see <http://www.gnu.org/licenses/>.
 * =====================================================================
 *
 * Created on January 22, 2008, 11:53 AM
 */

package jsattrak.customsat.gui;

import java.util.Vector;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import jsattrak.customsat.GoalParameter;
import name.gano.swingx.treetable.CustomTreeTableNode;

/**
 *
 * @author  sgano
 */
public class AddGoalParam extends javax.swing.JPanel
{
    
    CustomTreeTableNode solverNode;
    SolverPanel solvePan;
    
    DefaultTreeModel treeModel;
    
    /** Creates new form AddInputVar */
    public AddGoalParam(CustomTreeTableNode solverNode, SolverPanel solvePan)
    {
        this.solverNode = solverNode;
        this.solvePan = solvePan;
        
        initComponents();
        
        DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("Goals");
        treeModel = new DefaultTreeModel(rootNode); // create tree model using root node
        
        varTree.setModel(treeModel);
        
        //varTree.setRootVisible(false); // hide root (one less thing to worry about them clicking on)
        
        // setup the tree:
        varTree.removeAll();
        // for each Chile
        
        // NEED TO MAKE THIS RECURSIVE SO LOWER CHIL BRANCHES ARE INCLUDED?
        for(int i=0;i<solverNode.getChildCount();i++)
        {
            CustomTreeTableNode node = (CustomTreeTableNode)solverNode.getChildAt(i);
            Vector<GoalParameter> varVec = node.getGoalParamVector();
            
            // add Node
            DefaultMutableTreeNode treeNodeParent = new DefaultMutableTreeNode(node.getValueAt(0));
            
            rootNode.add(treeNodeParent);
            
            for(GoalParameter inVar : varVec)
            {
                treeNodeParent.add(  new DefaultMutableTreeNode( inVar ) );
                
                //System.out.println("added:" + inVar.toString());
            }
            
        } // for each Chile
        
        varTree.expandRow(0); // expand root
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        
        addVarButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        varTree = new javax.swing.JTree();
        
        addVarButton.setText("Add");
        addVarButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                addVarButtonActionPerformed(evt);
            }
        });
        
        jScrollPane1.setViewportView(varTree);
        
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(98, Short.MAX_VALUE)
                .addComponent(addVarButton)
                .addContainerGap())
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE)
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 273, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(addVarButton))
                );
    }// </editor-fold>//GEN-END:initComponents
    
    private void addVarButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addVarButtonActionPerformed
    {//GEN-HEADEREND:event_addVarButtonActionPerformed
        // see if selected node's Object is a variable
        TreePath[] treePaths = varTree.getSelectionPaths();
        
        for (int i = 0; i < treePaths.length; i++)
        {
            
            DefaultMutableTreeNode node = (DefaultMutableTreeNode)treePaths[i].getLastPathComponent();
            Object currentObj = node.getUserObject();
            
            if(currentObj instanceof GoalParameter)
            {
                GoalParameter iv = (GoalParameter) currentObj;
                
                // add to SolverPanel
                solvePan.addGoalParameter(iv);
                
            }
        }
    }//GEN-LAST:event_addVarButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addVarButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree varTree;
    // End of variables declaration//GEN-END:variables
    
}
